/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.ergebnis.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="ERGEBNIS.UK",
     query="SELECT o FROM Ergebnis o WHERE "

                         + "o"
                +".ergebnisart"
              +" = ?1"

             +" AND "         + "o"
                +".name"
              +" = ?2"

             +" AND "         + "o"
                +".wahl"
                +".wahlart"
                +".name"
              +" = ?3"

             +" AND "         + "o"
                +".wahl"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?4"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".nummer"
              +" = ?5"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".wahldatum"
              +" = ?6"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?7"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="ERGEBNIS.All",
     query="SELECT o FROM Ergebnis o",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNIS.NameAndErgebnisartAndWahlAutoComplete",
     query="SELECT o FROM Ergebnis o WHERE UPPER(o.name) LIKE UPPER(?1) AND o.ergebnisart=?2 and o.wahl = ?3",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNIS.WahlAndErgebnisart",
     query="SELECT o FROM Ergebnis o WHERE o.wahl = ?1 AND o.ergebnisart=?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNIS.Wahl",
     query="SELECT o FROM Ergebnis o WHERE o.wahl = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNIS.WahlOrderByName",
     query="SELECT o FROM Ergebnis o WHERE o.wahl = ?1 ORDER BY o.name",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "ERGEBNIS")
// @javax.persistence.IdClass(ErgebnisPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Ergebnis
extends AbstractErgebnis
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Ergebnis() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Ergebnis(Ergebnis original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "ergebnis_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Ergebnis")
    @javax.persistence.TableGenerator(name = "Ergebnis", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Ergebnis", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient ErgebnisPK pkCache;

  @Override
  public ErgebnisPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new ErgebnisPK(getId());
    }

    return pkCache;
  }

  public static <E extends Ergebnis> java.util.Map<ErgebnisPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<ErgebnisPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Ergebnis> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedAusloeser = false;
          hasChangedBemerkung = false;
          hasChangedEingangssequenznummer = false;
          hasChangedErgebnisart = false;
          hasChangedErgebnisStatus = false;
          hasChangedName = false;
          hasChangedSitzberechnungsalgorithmus = false;
          hasChangedZeitstempel = false;
  
      hasChangedWahl = false;
  

                        
    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "AUSLOESER", nullable = ErgebnisConstants.AUSLOESER_NULLABLE, length=ErgebnisConstants.AUSLOESER_MAX_LENGTH)
        
  protected java.lang.String ausloeser =  "Unbekannt";

  @javax.persistence.Transient
  protected boolean hasChangedAusloeser = false;

  public boolean hasChangedAusloeser(){
    return hasChangedAusloeser;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertAusloeser = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenAusloeser;
  
  /**
   * 
   *
   * getter for ERGEBNIS.AUSLOESER
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getAusloeser() {
        return ausloeser;
      }

  /**
   * 
   *
   * setter for ERGEBNIS.AUSLOESER
   *
   * @param ausloeser
   */
  @Override   public void setAusloeser(@javax.annotation.Nullable  java.lang.String ausloeser) {

       resetTkCache();
                  
                          java.lang.String ausloeserInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(ausloeser, ErgebnisConstants.AUSLOESER_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ausloeser
      , ausloeserInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedAusloeser |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("ausloeser");
      }


             if (!isSeitLadenVeraendertAusloeser) {
          isSeitLadenVeraendertAusloeser = thisAttributChanged;
         if (isSeitLadenVeraendertAusloeser){
           wertNachLadenAusloeser=this.ausloeser;
         }
       }
      

       this.ausloeser = ausloeserInternal;

         }

        
  @javax.persistence.Column(name = "BEMERKUNG", nullable = ErgebnisConstants.BEMERKUNG_NULLABLE, length=ErgebnisConstants.BEMERKUNG_MAX_LENGTH)
        
  protected java.lang.String bemerkung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBemerkung = false;

  public boolean hasChangedBemerkung(){
    return hasChangedBemerkung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBemerkung = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBemerkung;
  
  /**
   * 
   *
   * getter for ERGEBNIS.BEMERKUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBemerkung() {
        return bemerkung;
      }

  /**
   * 
   *
   * setter for ERGEBNIS.BEMERKUNG
   *
   * @param bemerkung
   */
  @Override   public void setBemerkung(@javax.annotation.Nullable  java.lang.String bemerkung) {

       resetTkCache();
                  
                          java.lang.String bemerkungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(bemerkung, ErgebnisConstants.BEMERKUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bemerkung
      , bemerkungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBemerkung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bemerkung");
      }


             if (!isSeitLadenVeraendertBemerkung) {
          isSeitLadenVeraendertBemerkung = thisAttributChanged;
         if (isSeitLadenVeraendertBemerkung){
           wertNachLadenBemerkung=this.bemerkung;
         }
       }
      

       this.bemerkung = bemerkungInternal;

         }

        
  @javax.persistence.Column(name = "EINGANGSSEQUENZNUMMER", nullable = ErgebnisConstants.EINGANGSSEQUENZNUMMER_NULLABLE, precision=ErgebnisConstants.EINGANGSSEQUENZNUMMER_PRECISION, scale=ErgebnisConstants.EINGANGSSEQUENZNUMMER_SCALE)
            // Feldname falsch => gemeint ist Ergebnissequenznummer
  protected java.lang.Long eingangssequenznummer =  null;

  @javax.persistence.Transient
  protected boolean hasChangedEingangssequenznummer = false;

  public boolean hasChangedEingangssequenznummer(){
    return hasChangedEingangssequenznummer;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertEingangssequenznummer = false;
     @javax.persistence.Transient
     private transient java.lang.Long wertNachLadenEingangssequenznummer;
  
  /**
   * 
   *
   * getter for ERGEBNIS.EINGANGSSEQUENZNUMMER
   */
  @javax.annotation.Nullable   @Override   public  java.lang.Long getEingangssequenznummer() {
        return eingangssequenznummer;
      }

  /**
   * 
   *
   * setter for ERGEBNIS.EINGANGSSEQUENZNUMMER
   *
   * @param eingangssequenznummer
   */
  @Override   public void setEingangssequenznummer(@javax.annotation.Nullable  java.lang.Long eingangssequenznummer) {

       resetTkCache();
                  java.lang.Long eingangssequenznummerInternal = eingangssequenznummer;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.eingangssequenznummer
      , eingangssequenznummerInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedEingangssequenznummer |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("eingangssequenznummer");
      }


             if (!isSeitLadenVeraendertEingangssequenznummer) {
          isSeitLadenVeraendertEingangssequenznummer = thisAttributChanged;
         if (isSeitLadenVeraendertEingangssequenznummer){
           wertNachLadenEingangssequenznummer=this.eingangssequenznummer;
         }
       }
      

       this.eingangssequenznummer = eingangssequenznummerInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "ERGEBNISART", nullable = ErgebnisConstants.ERGEBNISART_NULLABLE)
    
  protected de.ivu.elect.business.ergebnis.entity.Ergebnisart ergebnisart =  null;

  @javax.persistence.Transient
  protected boolean hasChangedErgebnisart = false;

  public boolean hasChangedErgebnisart(){
    return hasChangedErgebnisart;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertErgebnisart = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.ergebnis.entity.Ergebnisart wertNachLadenErgebnisart;
  
  /**
   * 
   *
   * getter for ERGEBNIS.ERGEBNISART
   */
    @Override   public  de.ivu.elect.business.ergebnis.entity.Ergebnisart getErgebnisart() {
        return ergebnisart;
      }

  /**
   * 
   *
   * setter for ERGEBNIS.ERGEBNISART
   *
   * @param ergebnisart
   */
  @Override   public void setErgebnisart( de.ivu.elect.business.ergebnis.entity.Ergebnisart ergebnisart) {

       resetTkCache();
                  de.ivu.elect.business.ergebnis.entity.Ergebnisart ergebnisartInternal = ergebnisart;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ergebnisart
      , ergebnisartInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedErgebnisart |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("ergebnisart");
      }


             if (!isSeitLadenVeraendertErgebnisart) {
          isSeitLadenVeraendertErgebnisart = thisAttributChanged;
         if (isSeitLadenVeraendertErgebnisart){
           wertNachLadenErgebnisart=this.ergebnisart;
         }
       }
      

       this.ergebnisart = ergebnisartInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "ERGEBNIS_STATUS", nullable = ErgebnisConstants.ERGEBNIS_STATUS_NULLABLE)
    
  protected de.ivu.elect.business.ergebnis.entity.ErgebnisStatus ergebnisStatus =  de.ivu.elect.business.ergebnis.entity.ErgebnisStatus.UNBEKANNT;

  @javax.persistence.Transient
  protected boolean hasChangedErgebnisStatus = false;

  public boolean hasChangedErgebnisStatus(){
    return hasChangedErgebnisStatus;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertErgebnisStatus = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.ergebnis.entity.ErgebnisStatus wertNachLadenErgebnisStatus;
  
  /**
   * 
   *
   * getter for ERGEBNIS.ERGEBNIS_STATUS
   */
    @Override   public  de.ivu.elect.business.ergebnis.entity.ErgebnisStatus getErgebnisStatus() {
        return ergebnisStatus;
      }

  /**
   * 
   *
   * setter for ERGEBNIS.ERGEBNIS_STATUS
   *
   * @param ergebnisStatus
   */
  @Override   public void setErgebnisStatus( de.ivu.elect.business.ergebnis.entity.ErgebnisStatus ergebnisStatus) {

       resetTkCache();
                  de.ivu.elect.business.ergebnis.entity.ErgebnisStatus ergebnisStatusInternal = ergebnisStatus;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ergebnisStatus
      , ergebnisStatusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedErgebnisStatus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("ergebnisStatus");
      }


             if (!isSeitLadenVeraendertErgebnisStatus) {
          isSeitLadenVeraendertErgebnisStatus = thisAttributChanged;
         if (isSeitLadenVeraendertErgebnisStatus){
           wertNachLadenErgebnisStatus=this.ergebnisStatus;
         }
       }
      

       this.ergebnisStatus = ergebnisStatusInternal;

         }

        
      @javax.persistence.Column(name = "NAME", nullable = ErgebnisConstants.NAME_NULLABLE, length=ErgebnisConstants.NAME_MAX_LENGTH)
        
  protected java.lang.String name =  null;

  @javax.persistence.Transient
  protected boolean hasChangedName = false;

  public boolean hasChangedName(){
    return hasChangedName;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertName = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenName;
  
  /**
   * 
   *
   * getter for ERGEBNIS.NAME
   */
    @Override   public  java.lang.String getName() {
        return name;
      }

  /**
   * 
   *
   * setter for ERGEBNIS.NAME
   *
   * @param name
   */
  @Override   public void setName( java.lang.String name) {

       resetTkCache();
                  
                          java.lang.String nameInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(name, ErgebnisConstants.NAME_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.name
      , nameInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedName |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("name");
      }


             if (!isSeitLadenVeraendertName) {
          isSeitLadenVeraendertName = thisAttributChanged;
         if (isSeitLadenVeraendertName){
           wertNachLadenName=this.name;
         }
       }
      

       this.name = nameInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "SITZBERECHNUNGSALGORITHMUS", nullable = ErgebnisConstants.SITZBERECHNUNGSALGORITHMUS_NULLABLE)
    
  protected de.ivu.elect.business.wahl.entity.WahlartSitzberechnungsalgorithmus sitzberechnungsalgorithmus =  de.ivu.elect.business.wahl.entity.WahlartSitzberechnungsalgorithmus.KEIN;

  @javax.persistence.Transient
  protected boolean hasChangedSitzberechnungsalgorithmus = false;

  public boolean hasChangedSitzberechnungsalgorithmus(){
    return hasChangedSitzberechnungsalgorithmus;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertSitzberechnungsalgorithmus = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.wahl.entity.WahlartSitzberechnungsalgorithmus wertNachLadenSitzberechnungsalgorithmus;
  
  /**
   * 
   *
   * getter for ERGEBNIS.SITZBERECHNUNGSALGORITHMUS
   */
    @Override   public  de.ivu.elect.business.wahl.entity.WahlartSitzberechnungsalgorithmus getSitzberechnungsalgorithmus() {
        return sitzberechnungsalgorithmus;
      }

  /**
   * 
   *
   * setter for ERGEBNIS.SITZBERECHNUNGSALGORITHMUS
   *
   * @param sitzberechnungsalgorithmus
   */
  @Override   public void setSitzberechnungsalgorithmus( de.ivu.elect.business.wahl.entity.WahlartSitzberechnungsalgorithmus sitzberechnungsalgorithmus) {

       resetTkCache();
                  de.ivu.elect.business.wahl.entity.WahlartSitzberechnungsalgorithmus sitzberechnungsalgorithmusInternal = sitzberechnungsalgorithmus;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.sitzberechnungsalgorithmus
      , sitzberechnungsalgorithmusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedSitzberechnungsalgorithmus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("sitzberechnungsalgorithmus");
      }


             if (!isSeitLadenVeraendertSitzberechnungsalgorithmus) {
          isSeitLadenVeraendertSitzberechnungsalgorithmus = thisAttributChanged;
         if (isSeitLadenVeraendertSitzberechnungsalgorithmus){
           wertNachLadenSitzberechnungsalgorithmus=this.sitzberechnungsalgorithmus;
         }
       }
      

       this.sitzberechnungsalgorithmus = sitzberechnungsalgorithmusInternal;

         }

        
  @javax.persistence.Temporal(javax.persistence.TemporalType.TIMESTAMP)
  @javax.persistence.Column(name = "ZEITSTEMPEL", nullable = ErgebnisConstants.ZEITSTEMPEL_NULLABLE, precision=ErgebnisConstants.ZEITSTEMPEL_PRECISION)
    
  protected java.util.Date zeitstempel =  null;

  @javax.persistence.Transient
  protected boolean hasChangedZeitstempel = false;

  public boolean hasChangedZeitstempel(){
    return hasChangedZeitstempel;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertZeitstempel = false;
     @javax.persistence.Transient
     private transient java.util.Date wertNachLadenZeitstempel;
  
  /**
   * 
   *
   * getter for ERGEBNIS.ZEITSTEMPEL
   */
  @javax.annotation.Nullable   @Override   public  java.util.Date getZeitstempel() {
              if (zeitstempel == null){
            return null;
          } else {
                          return zeitstempel;
          }
      }

  /**
   * 
   *
   * setter for ERGEBNIS.ZEITSTEMPEL
   *
   * @param zeitstempel
   */
  @Override   public void setZeitstempel(@javax.annotation.Nullable  java.util.Date zeitstempel) {

       resetTkCache();
                  java.util.Date zeitstempelInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDateTime(zeitstempel);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.zeitstempel
      , zeitstempelInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedZeitstempel |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("zeitstempel");
      }


             if (!isSeitLadenVeraendertZeitstempel) {
          isSeitLadenVeraendertZeitstempel = thisAttributChanged;
         if (isSeitLadenVeraendertZeitstempel){
           wertNachLadenZeitstempel=this.zeitstempel;
         }
       }
      

       this.zeitstempel = zeitstempelInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Wahl
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHL_ID", referencedColumnName="WAHL_ID"))
  protected de.ivu.elect.business.wahl.entity.Wahl wahl;

  /**
   * 
   */
  @Override
  public void setWahl( de.ivu.elect.business.wahl.entity.Wahl wahl){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahl
    , wahl);

    attributeChanged |= thisAttributChanged;

    hasChangedWahl |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahl");
    }

    this.wahl = wahl;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.wahl.entity.Wahl getWahl(){
    return this.wahl;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahl = false;

  public boolean hasChangedWahl(){
    return hasChangedWahl;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Ergebnis:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Ergebnis other){
                             other.ausloeser = this.ausloeser;
                                other.bemerkung = this.bemerkung;
                                other.eingangssequenznummer = this.eingangssequenznummer;
                                other.ergebnisart = this.ergebnisart;
                                other.ergebnisStatus = this.ergebnisStatus;
                                other.name = this.name;
                                other.sitzberechnungsalgorithmus = this.sitzberechnungsalgorithmus;
                                other.zeitstempel = this.zeitstempel;
           
  other.setWahl(this.getWahl());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Ergebnis.class)){
        copyEntityAttributesUsingSetter((Ergebnis) other.castTo(Ergebnis.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Ergebnis: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Ergebnis other){
               other.setAusloeser(this.ausloeser);
                  other.setBemerkung(this.bemerkung);
                  other.setEingangssequenznummer(this.eingangssequenznummer);
                  other.setErgebnisart(this.ergebnisart);
                  other.setErgebnisStatus(this.ergebnisStatus);
                  other.setName(this.name);
                  other.setSitzberechnungsalgorithmus(this.sitzberechnungsalgorithmus);
                  other.setZeitstempel(this.zeitstempel);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Ergebnis other){
                       if (hasChangedAusloeser) {
        other.setAusloeser(this.ausloeser);
      }
                             if (hasChangedBemerkung) {
        other.setBemerkung(this.bemerkung);
      }
                             if (hasChangedEingangssequenznummer) {
        other.setEingangssequenznummer(this.eingangssequenznummer);
      }
                             if (hasChangedErgebnisart) {
        other.setErgebnisart(this.ergebnisart);
      }
                             if (hasChangedErgebnisStatus) {
        other.setErgebnisStatus(this.ergebnisStatus);
      }
                             if (hasChangedName) {
        other.setName(this.name);
      }
                             if (hasChangedSitzberechnungsalgorithmus) {
        other.setSitzberechnungsalgorithmus(this.sitzberechnungsalgorithmus);
      }
                             if (hasChangedZeitstempel) {
        other.setZeitstempel(this.zeitstempel);
      }
             }





    @javax.persistence.Transient
    private transient ErgebnisTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public ErgebnisTK getErgebnisTK(){
    if (tkCache==null) {
    tkCache = new ErgebnisTK(

getErgebnisart()
, getName()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getErgebnisTK();
    }

  @Override
  public ErgebnisUK getUk(){
    return getErgebnisUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Ergebnis.class;
  }

public ErgebnisUK getErgebnisUK(){

   return  new ErgebnisUK(

getErgebnisart()
, getName()
,     getWahl()==null?null:getWahl().getWahlUK()


  );
}

  @javax.persistence.Transient
  private transient ErgebnisProperties properties;

  public ErgebnisProperties getProperties(){
    if (properties == null) {
      properties = new ErgebnisProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public ErgebnisProperties getErgebnisProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return ErgebnisConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(ErgebnisConstants.MESSAGE_KEY_AUSLOESER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(ErgebnisConstants.MESSAGE_KEY_AUSLOESER_EINZAHL);

        ausloeser =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(ErgebnisConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(ErgebnisConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL);

        bemerkung =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(ErgebnisConstants.MESSAGE_KEY_EINGANGSSEQUENZNUMMER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(ErgebnisConstants.MESSAGE_KEY_EINGANGSSEQUENZNUMMER_EINZAHL);

        eingangssequenznummer =
                        vorher.getAttributTyp().getValueAsLong(vorher.getWertVorher());
                  }

            
      if (werteVorher.containsKey(ErgebnisConstants.MESSAGE_KEY_ERGEBNISART_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(ErgebnisConstants.MESSAGE_KEY_ERGEBNISART_EINZAHL);

        ergebnisart =
     (de.ivu.elect.business.ergebnis.entity.Ergebnisart) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(ErgebnisConstants.MESSAGE_KEY_ERGEBNIS_STATUS_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(ErgebnisConstants.MESSAGE_KEY_ERGEBNIS_STATUS_EINZAHL);

        ergebnisStatus =
     (de.ivu.elect.business.ergebnis.entity.ErgebnisStatus) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(ErgebnisConstants.MESSAGE_KEY_NAME_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(ErgebnisConstants.MESSAGE_KEY_NAME_EINZAHL);

        name =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(ErgebnisConstants.MESSAGE_KEY_SITZBERECHNUNGSALGORITHMUS_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(ErgebnisConstants.MESSAGE_KEY_SITZBERECHNUNGSALGORITHMUS_EINZAHL);

        sitzberechnungsalgorithmus =
     (de.ivu.elect.business.wahl.entity.WahlartSitzberechnungsalgorithmus) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(ErgebnisConstants.MESSAGE_KEY_ZEITSTEMPEL_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(ErgebnisConstants.MESSAGE_KEY_ZEITSTEMPEL_EINZAHL);

        zeitstempel =
     vorher.getAttributTyp().getValueAsDate(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertAusloeser) {
      result.put(ErgebnisConstants.MESSAGE_KEY_AUSLOESER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenAusloeser , ausloeser));
    }
                            if (isSeitLadenVeraendertBemerkung) {
      result.put(ErgebnisConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBemerkung , bemerkung));
    }
                            if (isSeitLadenVeraendertEingangssequenznummer) {
      result.put(ErgebnisConstants.MESSAGE_KEY_EINGANGSSEQUENZNUMMER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.LONG
                            , wertNachLadenEingangssequenznummer , eingangssequenznummer));
    }
                            if (isSeitLadenVeraendertErgebnisart) {
      result.put(ErgebnisConstants.MESSAGE_KEY_ERGEBNISART_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenErgebnisart , ergebnisart));
    }
                            if (isSeitLadenVeraendertErgebnisStatus) {
      result.put(ErgebnisConstants.MESSAGE_KEY_ERGEBNIS_STATUS_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenErgebnisStatus , ergebnisStatus));
    }
                            if (isSeitLadenVeraendertName) {
      result.put(ErgebnisConstants.MESSAGE_KEY_NAME_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenName , name));
    }
                            if (isSeitLadenVeraendertSitzberechnungsalgorithmus) {
      result.put(ErgebnisConstants.MESSAGE_KEY_SITZBERECHNUNGSALGORITHMUS_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenSitzberechnungsalgorithmus , sitzberechnungsalgorithmus));
    }
                            if (isSeitLadenVeraendertZeitstempel) {
      result.put(ErgebnisConstants.MESSAGE_KEY_ZEITSTEMPEL_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.TIMESTAMP
                , wertNachLadenZeitstempel , zeitstempel));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertAusloeser = false;
      wertNachLadenAusloeser = null;
                          isSeitLadenVeraendertBemerkung = false;
      wertNachLadenBemerkung = null;
                          isSeitLadenVeraendertEingangssequenznummer = false;
      wertNachLadenEingangssequenznummer = null;
                          isSeitLadenVeraendertErgebnisart = false;
      wertNachLadenErgebnisart = null;
                          isSeitLadenVeraendertErgebnisStatus = false;
      wertNachLadenErgebnisStatus = null;
                          isSeitLadenVeraendertName = false;
      wertNachLadenName = null;
                          isSeitLadenVeraendertSitzberechnungsalgorithmus = false;
      wertNachLadenSitzberechnungsalgorithmus = null;
                          isSeitLadenVeraendertZeitstempel = false;
      wertNachLadenZeitstempel = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "ERGEBNIS";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Ergebnis";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(ErgebnisConstants.AUSLOESER_MAX_LENGTH ,  ausloeser, this, ErgebnisConstants.MESSAGE_KEY_AUSLOESER_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(ErgebnisConstants.BEMERKUNG_MAX_LENGTH ,  bemerkung, this, ErgebnisConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(ErgebnisConstants.EINGANGSSEQUENZNUMMER_MAX_VALUE, ErgebnisConstants.EINGANGSSEQUENZNUMMER_MIN_VALUE, eingangssequenznummer, this, ErgebnisConstants.MESSAGE_KEY_EINGANGSSEQUENZNUMMER_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(ergebnisart, this, ErgebnisConstants.MESSAGE_KEY_ERGEBNISART_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(ergebnisStatus, this, ErgebnisConstants.MESSAGE_KEY_ERGEBNIS_STATUS_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(name, this, ErgebnisConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(ErgebnisConstants.NAME_MAX_LENGTH , 1 ,  name, this, ErgebnisConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(sitzberechnungsalgorithmus, this, ErgebnisConstants.MESSAGE_KEY_SITZBERECHNUNGSALGORITHMUS_EINZAHL, validationResult);
                                                                                                                             }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
